import QtQuick 2.15
import QtQuick.Controls 2.15
import QtQuick.Layouts 1.15
import "./creater.mjs" as MJ
import "./creater.js" as JS

Rectangle {
  id: root
  width: 400
  height: 600

  ColumnLayout {
    anchors.left: parent.left
    anchors.right: parent.right
    anchors.top: parent.top

    Button {
      text: qsTr("(.mjs) With property [Crash]")
      onClicked: {
        MJ.withProp(root)
      }
    }

    Button {
      text: qsTr("(.mjs) With empty property [Crash]")
      onClicked: {
        MJ.emptyProp(root)
      }
    }

    Button {
      text: qsTr("(.mjs) Without property")
      onClicked: {
        MJ.noProp(root)
      }
    }

    Button {
      text: qsTr("(.js) With property")
      onClicked: {
        JS.withProp(root)
      }
    }

    Button {
      text: qsTr("(Inline) With property")
      onClicked: {
        const READY = 1;
        const ERROR = 3;

        const component = Qt.createComponent("MyDialog.qml");
        if (component.status === ERROR) {
          console.error("Failed to create error dialog", component.errorString());
          return;
        }

        if (component.status !== READY) {
          console.error("Component is not ready. Skipping showing error dialog");
          return;
        }

        console.log(
          "Imported component",
          component.status,
          component.progress,
          component.errorString()
        );
        const el = component.createObject(root, { title: "B" });
        el.open();
      }
    }
  }
}
