// Got issue with the dot syntax for importing QtQuick
// Hard-coding Component.status enum here
const READY = 1;
const ERROR = 3;

export function withProp(root) {
  const component = Qt.createComponent("MyDialog.qml");
  if (component.status === ERROR) {
    console.error("Failed to create error dialog", component.errorString());
    return;
  }

  if (component.status !== READY) {
    console.error("Component is not ready. Skipping showing error dialog");
    return;
  }

  console.log(
    "Imported component",
    component.status,
    component.progress,
    component.errorString()
  );
  const el = component.createObject(root, { title: "B" });
  el.open();
}

export function emptyProp(root) {
  const component = Qt.createComponent("MyDialog.qml");
  if (component.status === ERROR) {
    console.error("Failed to create error dialog", component.errorString());
    return;
  }

  if (component.status !== READY) {
    console.error("Component is not ready. Skipping showing error dialog");
    return;
  }

  console.log(
    "Imported component",
    component.status,
    component.progress,
    component.errorString()
  );
  const el = component.createObject(root, {});
  el.open();
}

export function noProp(root) {
  const component = Qt.createComponent("MyDialog.qml");
  if (component.status === ERROR) {
    console.error("Failed to create error dialog", component.errorString());
    return;
  }

  if (component.status !== READY) {
    console.error("Component is not ready. Skipping showing error dialog");
    return;
  }

  console.log(
    "Imported component",
    component.status,
    component.progress,
    component.errorString()
  );
  const el = component.createObject(root);
  el.open();
}
